'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms

Friend Class aosEquipSlotArray : Inherits System.Collections.CollectionBase

    Public Function AddNew(ByVal page As Integer, ByVal slot As Integer) As aosEquipSlot
        Dim aES As New aosEquipSlot(page, slot)

        ' Add to the collection
        Me.List.Add(aES)
        Return aES
    End Function

    Public Sub Remove()
        ' Check to be sure there is an object to remove.
        If Me.Count > 0 Then
            Me.List.RemoveAt(Me.Count - 1)
        End If
    End Sub

    Default Public ReadOnly Property Item(ByVal Index As Integer) As aosEquipSlot
        Get
            Return CType(Me.List.Item(Index), aosEquipSlot)
        End Get
    End Property

End Class
