'Copyright (c) 2003-2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Public Class aosHPNPItem : Inherits UserControl

    Private prvBaseValue As Integer = 0
    Private prvItemName As String = "Name"
    Private prvItemID As Integer = -1
    Private prvHandler As EventHandler
    Private prvTabPage As TabPage
    Private prvUseHandler As Boolean = False
    Friend WithEvents txtBuff As TextBox

    Private prvTrackValue As Long

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
        Me.Implant = 0
        Me.Buff = 0
        Me.Other = 0
        Me.Perk = 0
        Me.Misc = 0
        SetScale()
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents nudOther As System.Windows.Forms.TextBox
    Friend WithEvents nudImplant As System.Windows.Forms.TextBox
    Friend WithEvents lblValue As System.Windows.Forms.Label
    Friend WithEvents lblName As System.Windows.Forms.Label
    Friend WithEvents nudMisc As System.Windows.Forms.TextBox
    Friend WithEvents nudPerk As System.Windows.Forms.TextBox
    Friend WithEvents nudBuff As System.Windows.Forms.NumericUpDown
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.nudOther = New System.Windows.Forms.TextBox()
        Me.nudImplant = New System.Windows.Forms.TextBox()
        Me.lblValue = New System.Windows.Forms.Label()
        Me.lblName = New System.Windows.Forms.Label()
        Me.nudMisc = New System.Windows.Forms.TextBox()
        Me.nudPerk = New System.Windows.Forms.TextBox()
        Me.nudBuff = New System.Windows.Forms.NumericUpDown()
        Me.txtBuff = New System.Windows.Forms.TextBox()
        CType(Me.nudBuff, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'nudOther
        '
        Me.nudOther.BackColor = System.Drawing.Color.White
        Me.nudOther.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudOther.Location = New System.Drawing.Point(442, 0)
        Me.nudOther.MinimumSize = New System.Drawing.Size(56, 26)
        Me.nudOther.Name = "nudOther"
        Me.nudOther.ReadOnly = True
        Me.nudOther.Size = New System.Drawing.Size(56, 26)
        Me.nudOther.TabIndex = 4
        Me.nudOther.Text = "0"
        Me.nudOther.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'nudImplant
        '
        Me.nudImplant.BackColor = System.Drawing.Color.White
        Me.nudImplant.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudImplant.Location = New System.Drawing.Point(330, 0)
        Me.nudImplant.MinimumSize = New System.Drawing.Size(56, 26)
        Me.nudImplant.Name = "nudImplant"
        Me.nudImplant.ReadOnly = True
        Me.nudImplant.Size = New System.Drawing.Size(56, 26)
        Me.nudImplant.TabIndex = 2
        Me.nudImplant.Text = "0"
        Me.nudImplant.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'lblValue
        '
        Me.lblValue.AutoSize = True
        Me.lblValue.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblValue.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblValue.Location = New System.Drawing.Point(200, 0)
        Me.lblValue.MinimumSize = New System.Drawing.Size(56, 26)
        Me.lblValue.Name = "lblValue"
        Me.lblValue.Size = New System.Drawing.Size(56, 26)
        Me.lblValue.TabIndex = 1
        Me.lblValue.Text = "0"
        Me.lblValue.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblName
        '
        Me.lblName.AutoSize = True
        Me.lblName.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblName.Location = New System.Drawing.Point(0, 0)
        Me.lblName.Name = "lblName"
        Me.lblName.Size = New System.Drawing.Size(53, 19)
        Me.lblName.TabIndex = 9
        Me.lblName.Text = "Name"
        Me.lblName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'nudMisc
        '
        Me.nudMisc.BackColor = System.Drawing.Color.White
        Me.nudMisc.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudMisc.Location = New System.Drawing.Point(554, 0)
        Me.nudMisc.MinimumSize = New System.Drawing.Size(56, 26)
        Me.nudMisc.Name = "nudMisc"
        Me.nudMisc.ReadOnly = True
        Me.nudMisc.Size = New System.Drawing.Size(56, 26)
        Me.nudMisc.TabIndex = 6
        Me.nudMisc.Text = "0"
        Me.nudMisc.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'nudPerk
        '
        Me.nudPerk.BackColor = System.Drawing.Color.White
        Me.nudPerk.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudPerk.Location = New System.Drawing.Point(498, 0)
        Me.nudPerk.MinimumSize = New System.Drawing.Size(56, 26)
        Me.nudPerk.Name = "nudPerk"
        Me.nudPerk.ReadOnly = True
        Me.nudPerk.Size = New System.Drawing.Size(56, 26)
        Me.nudPerk.TabIndex = 5
        Me.nudPerk.Text = "0"
        Me.nudPerk.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'nudBuff
        '
        Me.nudBuff.BackColor = System.Drawing.Color.White
        Me.nudBuff.Enabled = False
        Me.nudBuff.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudBuff.Location = New System.Drawing.Point(386, 0)
        Me.nudBuff.Maximum = New Decimal(New Integer() {50000, 0, 0, 0})
        Me.nudBuff.Name = "nudBuff"
        Me.nudBuff.Size = New System.Drawing.Size(56, 26)
        Me.nudBuff.TabIndex = 17
        Me.nudBuff.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtBuff
        '
        Me.txtBuff.BackColor = System.Drawing.Color.White
        Me.txtBuff.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtBuff.Location = New System.Drawing.Point(386, 0)
        Me.txtBuff.MinimumSize = New System.Drawing.Size(56, 26)
        Me.txtBuff.Name = "txtBuff"
        Me.txtBuff.ReadOnly = True
        Me.txtBuff.Size = New System.Drawing.Size(56, 26)
        Me.txtBuff.TabIndex = 3
        Me.txtBuff.Text = "0"
        Me.txtBuff.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'aosHPNPItem
        '
        Me.AutoSize = True
        Me.Controls.Add(Me.txtBuff)
        Me.Controls.Add(Me.nudBuff)
        Me.Controls.Add(Me.nudPerk)
        Me.Controls.Add(Me.nudMisc)
        Me.Controls.Add(Me.nudOther)
        Me.Controls.Add(Me.nudImplant)
        Me.Controls.Add(Me.lblValue)
        Me.Controls.Add(Me.lblName)
        Me.MinimumSize = New System.Drawing.Size(624, 29)
        Me.Name = "aosHPNPItem"
        Me.Size = New System.Drawing.Size(624, 29)
        CType(Me.nudBuff, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Public ReadOnly Property Value() As String
        Get
            Return CStr(prvBaseValue + Me.nudBuff.Value + CInt(Me.nudImplant.Text) + CInt(Me.nudOther.Text) + CInt(Me.nudPerk.Text) + CInt(Me.nudMisc.Text))
        End Get
    End Property

    Public ReadOnly Property NakedValue() As String
        Get
            Return CStr(prvBaseValue + Me.nudBuff.Value + CInt(Me.nudPerk.Text) + CInt(Me.nudMisc.Text))
        End Get
    End Property

    Public Property UseHandler() As Boolean
        Get
            Return prvUseHandler
        End Get
        Set(ByVal Value As Boolean)
            prvUseHandler = Value
        End Set
    End Property

    Public Property ItemName() As String
        Get
            Return prvItemName
        End Get
        Set(ByVal Value As String)
            prvItemName = Value
            Me.lblName.Text = prvItemName
        End Set
    End Property

    Public Property ItemID() As Integer
        Get
            Return prvItemID
        End Get
        Set(ByVal Value As Integer)
            prvItemID = Value
        End Set
    End Property

    Public Property BaseValue() As Integer
        Get
            Return prvBaseValue
        End Get
        Set(ByVal Value As Integer)
            prvBaseValue = Value
            changed()
        End Set
    End Property

    Public Property Buff() As Long
        Get
            Return CLng(Me.nudBuff.Text)
        End Get
        Set(ByVal Value As Long)
            Me.nudBuff.Text = CStr(Value)
            Me.txtBuff.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property Implant() As Integer
        Get
            Return CInt(Me.nudImplant.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudImplant.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property Other() As Integer
        Get
            Return CInt(Me.nudOther.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudOther.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property Perk() As Integer
        Get
            Return CInt(Me.nudPerk.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudPerk.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property Misc() As Integer
        Get
            Return CInt(Me.nudMisc.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudMisc.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property ControlTabPage() As TabPage
        Get
            Return prvTabPage
        End Get
        Set(ByVal Value As TabPage)
            prvTabPage = Value
        End Set
    End Property

    Public Property ChangeHandler() As EventHandler
        Get
            Return prvHandler
        End Get
        Set(ByVal Value As EventHandler)
            prvHandler = Value
        End Set
    End Property

    Private Sub changed()
        Me.lblValue.Text = CStr(prvBaseValue + Me.nudBuff.Value + CInt(Me.nudImplant.Text) + CInt(Me.nudOther.Text) + CInt(Me.nudPerk.Text) + CInt(Me.nudMisc.Text))
    End Sub

    Private Sub SetScale()
        ' determine ratio of actual height to minimum height
        Dim ratio As Double = Me.Size.Height / Me.MinimumSize.Height
        ' the rescale all objects widths based on that ration (lblName should scale itself?)
        Me.Width = CInt(Me.MinimumSize.Width * ratio)
        Me.lblValue.Width = CInt(Me.lblValue.MinimumSize.Width * ratio)
        Me.nudImplant.Width = CInt(Me.nudImplant.MinimumSize.Width * ratio)
        Me.txtBuff.Width = CInt(Me.txtBuff.MinimumSize.Width * ratio)
        Me.nudOther.Width = CInt(Me.nudOther.MinimumSize.Width * ratio)
        Me.nudPerk.Width = CInt(Me.nudPerk.MinimumSize.Width * ratio)
        Me.nudMisc.Width = CInt(Me.nudMisc.MinimumSize.Width * ratio)
    End Sub

End Class
