'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Module modConstants

    ' for skills etc
    Public Const BASE_SKILL As Integer = 5    ' *** base value for all skills ***
    Public Const NUM_SKILLS As Integer = 69
    Public Const NUM_ATTRS As Integer = 6
    Public Const NUM_PROFS As Integer = 14
    Public Const NUM_BREEDS As Integer = 4
    Public Const NUM_OTHER_STATS As Integer = 54
    Public Const INIT_MAX_IMPROVE As Integer = 3
    Public Const INIT_AVAIL_IP As Int32 = 1500

    ' used to enable cyborg imps
    Public Const ATROX_ID As Integer = 3

    ' used to enable spirits
    Public Const SHADE_ID As Integer = 11

    Public Const NUM_EQUIP_SLOTS As Integer = 30
    Public Const MAX_IMPS As Integer = 12
    Public Const NUM_OB_BONUSES As Integer = 12

    Public Const EQUIP_MODS As Integer = 0
    Public Const IMP_MODS As Integer = 1
    Public Const PERK_MODS As Integer = 2
    Public Const BUFF_MODS As Integer = 3
    Public Const ORG_MODS As Integer = 4

    ' for empty implant slots
    Public Const SEL_STRING As String = "                   ...                   "

    ' for preferences
    Public Const FORM_MAIN As Integer = 0
    Public Const FORM_EQUP As Integer = 1
    Public Const FORM_IMPLANT As Integer = 2
    Public Const FORM_BUFF As Integer = 3
    Public Const FORM_ORG As Integer = 4
    Public Const FORM_TOP As Integer = 0
    Public Const FORM_LEFT As Integer = 1
    Public Const FORM_WIDTH As Integer = 2
    Public Const FORM_HEIGHT As Integer = 3
    Public Const CHECK_EQUIP As Integer = 0
    Public Const CHECK_IMPLANT As Integer = 1

    ' used to specify type when getting modifiers for an item
    Public Const MOD_EQUIP As Integer = 1
    Public Const MOD_BUFFS As Integer = 2
    Public Const MOD_BENEFITS As Integer = 3

End Module
