'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Public Class clsBuff

    Private prv_BuffAOID As Integer
    Private prv_BuffName As String
    Private prv_BuffProf As Integer
    Private prv_BuffSelf As Boolean
    Private prv_IsSelected As Boolean
    Private prv_IsFPAble As Boolean

    Public Sub New(ByVal aoid As Integer, ByRef name As String, ByVal prof As Integer, ByVal self As Integer, ByVal fpable As Integer)
        MyBase.New()
        prv_BuffAOID = aoid
        prv_BuffName = name
        prv_BuffProf = prof
        prv_BuffSelf = CBool(self)
        prv_IsSelected = False
        prv_IsFPAble = CBool(fpable)
    End Sub

    Public ReadOnly Property AOID() As Integer
        Get
            Return prv_BuffAOID
        End Get
    End Property

    Public ReadOnly Property Name() As String
        Get
            Return prv_BuffName
        End Get
    End Property

    Public ReadOnly Property Prof() As Integer
        Get
            Return prv_BuffProf
        End Get
    End Property

    Public ReadOnly Property IsSelf() As Boolean
        Get
            Return prv_BuffSelf
        End Get
    End Property

    Public ReadOnly Property IsFPAble() As Boolean
        Get
            Return prv_IsFPAble
        End Get
    End Property

    Public Property Selected() As Boolean
        Get
            Return prv_IsSelected
        End Get
        Set(value As Boolean)
            prv_IsSelected = value
        End Set
    End Property

End Class
