'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms

Friend Class clsBuffArray : Inherits System.Collections.CollectionBase

    Public Function AddNew(ByVal aoid As Integer, ByRef name As String, ByVal prof As Integer, ByVal target As Integer, ByVal fpable As Integer) As clsBuff
        Dim aBuff As New clsBuff(aoid, name, prof, target, fpable)

        ' Add to the collection
        Me.List.Add(aBuff)
        Return aBuff
    End Function

    Public Sub Remove()
        ' Check to be sure there is an object to remove.
        If Me.Count > 0 Then
            Me.List.RemoveAt(Me.Count - 1)
        End If
    End Sub

    Default Public ReadOnly Property Item(ByVal Index As Integer) As clsBuff
        Get
            Return CType(Me.List.Item(Index), clsBuff)
        End Get
    End Property

    Public Function Find(ByVal aoid As Integer) As clsBuff
        Dim r As clsBuff = Nothing
        For Each b As clsBuff In Me
            If b.AOID = aoid Then
                r = b
                Exit For
            End If
        Next
        Return r
    End Function

End Class
