'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System

Public Class clsOrgBenefit

    Private prv_BenefitAOID As Integer
    Private prv_BenefitName As String
    Private prv_BenefitMinQL As Integer
    Private prv_BenefitMaxQL As Integer
    Private prv_BenefitQL As Integer
    Private prv_BenefitType As String

    Public Sub New(ByVal aoid As Integer, ByRef name As String, ByVal ql As Integer, ByRef type As String)
        MyBase.New()
        prv_BenefitAOID = aoid
        prv_BenefitName = name
        prv_BenefitQL = ql
        prv_BenefitType = type
    End Sub

    Public ReadOnly Property AOID() As Integer
        Get
            Return prv_BenefitAOID
        End Get
    End Property

    Public ReadOnly Property Name() As String
        Get
            Return prv_BenefitName
        End Get
    End Property

    Public Property MinQL() As Integer
        Get
            Return prv_BenefitMinQL
        End Get
        Set(ByVal Value As Integer)
            prv_BenefitMinQL = Value
        End Set
    End Property

    Public Property MaxQL() As Integer
        Get
            Return prv_BenefitMaxQL
        End Get
        Set(ByVal Value As Integer)
            prv_BenefitMaxQL = Value
        End Set
    End Property

    Public ReadOnly Property QL() As Integer
        Get
            Return prv_BenefitQL
        End Get
    End Property

    Public ReadOnly Property Type() As String
        Get
            Return prv_BenefitType
        End Get
    End Property

End Class
